<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: llg/rhsfunction.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_ad11b878d2835527517911859427b54f.html">llg</a>
  </div>
</div>
<div class="contents">
<h1>rhsfunction.c</h1><a href="rhsfunction_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of magpar.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    Copyright (C) 2002-2010 Werner Scholz</span>
<a name="l00005"></a>00005 <span class="comment"></span>
<a name="l00006"></a>00006 <span class="comment">    www:   http://www.magpar.net/</span>
<a name="l00007"></a>00007 <span class="comment">    email: magpar(at)magpar.net</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">    magpar is free software; you can redistribute it and/or modify</span>
<a name="l00010"></a>00010 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00011"></a>00011 <span class="comment">    the Free Software Foundation; either version 2 of the License, or</span>
<a name="l00012"></a>00012 <span class="comment">    (at your option) any later version.</span>
<a name="l00013"></a>00013 <span class="comment"></span>
<a name="l00014"></a>00014 <span class="comment">    magpar is distributed in the hope that it will be useful,</span>
<a name="l00015"></a>00015 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00016"></a>00016 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00017"></a>00017 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00020"></a>00020 <span class="comment">    along with magpar; if not, write to the Free Software</span>
<a name="l00021"></a>00021 <span class="comment">    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00022"></a>00022 <span class="comment">*/</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Id[] = <span class="stringliteral">&quot;$Id: rhsfunction.c 2962 2010-02-04 19:50:44Z scholz $\n\n&quot;</span>;
<a name="l00025"></a>00025 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Td[] = <span class="stringliteral">&quot;$Today: &quot;</span> __FILE__ <span class="stringliteral">&quot;  &quot;</span> __DATE__ <span class="stringliteral">&quot;  &quot;</span>  __TIME__  <span class="stringliteral">&quot; $\n\n&quot;</span>;
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="llg_8h.html">llg.h</a>&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="keyword">static</span> Vec dMdt=PETSC_NULL;
<a name="l00030"></a>00030 
<a name="l00031"></a><a class="code" href="rhsfunction_8c.html#a5e964b5572e1640d9a793c353f6a28f6">00031</a> <span class="keywordtype">int</span> <a class="code" href="rhsfunction_8c.html#a5e964b5572e1640d9a793c353f6a28f6">RHSfunction</a>(realtype t,N_Vector u,N_Vector udot,<span class="keywordtype">void</span> *f_data)
<a name="l00032"></a>00032 {
<a name="l00033"></a>00033   <a class="code" href="structGridData.html">GridData</a>     *gdata = (<a class="code" href="structGridData.html">GridData</a>*)f_data;
<a name="l00034"></a>00034 
<a name="l00035"></a>00035   <a class="code" href="griddata_8h.html#a4e81d68a7df0ff55ea65b46253e07552">MagparFunctionInfoBegin</a>;
<a name="l00036"></a>00036   t_t2=0; <span class="comment">/* just to avoid warning about unused variable */</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038   <span class="comment">/* SUNDIALS&lt;230: must not use CHKERRQ here because we have to return void */</span>
<a name="l00039"></a>00039   <span class="keywordflow">if</span> (dMdt==PETSC_NULL) {
<a name="l00040"></a>00040     <span class="comment">/* FIXME: use VecCreateMPIWithArray instead!? */</span>
<a name="l00041"></a>00041     ierr = VecDuplicate(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,&amp;dMdt);
<a name="l00042"></a>00042   }
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 <span class="preprocessor">#ifdef UNIPROC</span>
<a name="l00045"></a>00045 <span class="preprocessor"></span>  ierr = VecPlaceArray(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,NV_DATA_S(u));
<a name="l00046"></a>00046   ierr = VecPlaceArray(dMdt,NV_DATA_S(udot));
<a name="l00047"></a>00047 <span class="preprocessor">#else</span>
<a name="l00048"></a>00048 <span class="preprocessor"></span>  ierr = VecPlaceArray(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,NV_DATA_P(u));
<a name="l00049"></a>00049   ierr = VecPlaceArray(dMdt,NV_DATA_P(udot));
<a name="l00050"></a>00050 <span class="preprocessor">#endif</span>
<a name="l00051"></a>00051 <span class="preprocessor"></span>
<a name="l00052"></a>00052   <span class="comment">/* set time to get time dependent parts (e.g. Hext) right */</span>
<a name="l00053"></a>00053   gdata-&gt;<a class="code" href="structGridData.html#a9eb9246406e97a2a4a8a9c471b11aa2a">time</a>=t;
<a name="l00054"></a>00054 
<a name="l00055"></a>00055   <a class="code" href="calc__dMdt_8c.html#aa814b25d7c7a65198ca75426fb6d7403">calc_dMdt</a>(PETSC_NULL,0.0,gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,dMdt,gdata);
<a name="l00056"></a>00056 
<a name="l00057"></a>00057   <span class="comment">/* We could use this differential dMdt to set vequil.</span>
<a name="l00058"></a>00058 <span class="comment">     However, there is more noise in dMdt than if we take the finite difference over one full time step</span>
<a name="l00059"></a>00059 <span class="comment">     using the EquilCheck functions.</span>
<a name="l00060"></a>00060 <span class="comment">  #include &quot;util/util.h&quot;</span>
<a name="l00061"></a>00061 <span class="comment">  gdata-&gt;vequil=RenormVec(dMdt,0.0,PETSC_MAX,ND);</span>
<a name="l00062"></a>00062 <span class="comment">  */</span>
<a name="l00063"></a>00063 
<a name="l00064"></a>00064   ierr = VecResetArray(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>);
<a name="l00065"></a>00065   ierr = VecResetArray(dMdt);
<a name="l00066"></a>00066 
<a name="l00067"></a>00067 <span class="preprocessor">#if SUNDIALS_VERSION &gt;= 230</span>
<a name="l00068"></a>00068 <span class="preprocessor"></span>  <a class="code" href="griddata_8h.html#a9a4d090c28602d7ff7ec883fb6f413db">MagparFunctionProfReturn</a>(0);
<a name="l00069"></a>00069 <span class="preprocessor">#else</span>
<a name="l00070"></a>00070 <span class="preprocessor"></span>  PetscFunctionReturnVoid();
<a name="l00071"></a>00071 <span class="preprocessor">#endif</span>
<a name="l00072"></a>00072 <span class="preprocessor"></span>}
<a name="l00073"></a>00073 
</pre></div></div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

